<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Robert Detjens">
  <meta name="author" content="OSU LUG">
  <title>All About SystemD</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reset.css">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reveal.css">
  <style>
    .reveal .sourceCode {  /* see #7635 */
      overflow: visible;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    pre > code.sourceCode { white-space: pre; position: relative; }
    pre > code.sourceCode > span { display: inline-block; line-height: 1.25; }
    pre > code.sourceCode > span:empty { height: 1.2em; }
    .sourceCode { overflow: visible; }
    code.sourceCode > span { color: inherit; text-decoration: inherit; }
    div.sourceCode { margin: 1em 0; }
    pre.sourceCode { margin: 0; }
    @media screen {
    div.sourceCode { overflow: auto; }
    }
    @media print {
    pre > code.sourceCode { white-space: pre-wrap; }
    pre > code.sourceCode > span { text-indent: -5em; padding-left: 5em; }
    }
    pre.numberSource code
      { counter-reset: source-line 0; }
    pre.numberSource code > span
      { position: relative; left: -4em; counter-increment: source-line; }
    pre.numberSource code > span > a:first-child::before
      { content: counter(source-line);
        position: relative; left: -1em; text-align: right; vertical-align: baseline;
        border: none; display: inline-block;
        -webkit-touch-callout: none; -webkit-user-select: none;
        -khtml-user-select: none; -moz-user-select: none;
        -ms-user-select: none; user-select: none;
        padding: 0 4px; width: 4em;
        color: #aaaaaa;
      }
    pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
    div.sourceCode
      {   }
    @media screen {
    pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
    }
    code span.al { color: #ff0000; font-weight: bold; } /* Alert */
    code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
    code span.at { color: #7d9029; } /* Attribute */
    code span.bn { color: #40a070; } /* BaseN */
    code span.bu { } /* BuiltIn */
    code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
    code span.ch { color: #4070a0; } /* Char */
    code span.cn { color: #880000; } /* Constant */
    code span.co { color: #60a0b0; font-style: italic; } /* Comment */
    code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
    code span.do { color: #ba2121; font-style: italic; } /* Documentation */
    code span.dt { color: #902000; } /* DataType */
    code span.dv { color: #40a070; } /* DecVal */
    code span.er { color: #ff0000; font-weight: bold; } /* Error */
    code span.ex { } /* Extension */
    code span.fl { color: #40a070; } /* Float */
    code span.fu { color: #06287e; } /* Function */
    code span.im { } /* Import */
    code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
    code span.kw { color: #007020; font-weight: bold; } /* Keyword */
    code span.op { color: #666666; } /* Operator */
    code span.ot { color: #007020; } /* Other */
    code span.pp { color: #bc7a00; } /* Preprocessor */
    code span.sc { color: #4070a0; } /* SpecialChar */
    code span.ss { color: #bb6688; } /* SpecialString */
    code span.st { color: #4070a0; } /* String */
    code span.va { color: #19177c; } /* Variable */
    code span.vs { color: #4070a0; } /* VerbatimString */
    code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/theme/black.css" id="theme">
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">All About SystemD</h1>
  <p class="author">Robert Detjens</p>
  <p class="author">OSU LUG</p>
  <p class="date">4/5/2022</p>
</section>

<section id="what-is-systemd" class="title-slide slide level1">
<h1>What is <code>systemd</code>?</h1>
<p>PID 1: system init</p>
<p>Sets up the system</p>
<p>provides a “system layer”</p>
</section>

<section>
<section id="some-history" class="title-slide slide level1">
<h1>Some History</h1>

</section>
<section id="what-is-init" class="slide level2">
<h2>What is <code>init</code>?</h2>
<pre><code>INIT(8)                               System Manager&#39;s Manual                              INIT(8)

NAME
        init, rc  -  process control initialization

DESCRIPTION
        Init is invoked as the last step of the boot procedure (see boot(8)).  Generally its role
        is to create a process for each typewriter on which a user may log in.

        (...)

        When init comes up multiuser, it invokes a shell, with input taken from the file /etc/rc.
        This command file performs housekeeping like removing temporary files, mounting file
        systems, and starting daemons.
</code></pre>
</section>
<section id="unix-was-simple." class="slide level2">
<h2>Unix was simple.</h2>
<figure>
<img data-src="images/pdp1170unix.png" height="500"
alt="Seventh Edition Unix on a PDP-11" />
<figcaption aria-hidden="true">Seventh Edition Unix on a
PDP-11</figcaption>
</figure>
</section>
<section class="slide level2">

<figure>
<img data-src="images/vax11730bsd.png" height="500"
alt="BSD 4 on a VAX 11/730" />
<figcaption aria-hidden="true">BSD 4 on a VAX 11/730</figcaption>
</figure>
</section>
<section class="slide level2">

<div class="columns">
<div class="column" style="width:50%;">
<p><code>init</code></p>
<ul>
<li>started getty for TTYs ( <code>Ct+Al+F#</code> )</li>
<li>mounted filesystems</li>
<li>ran shell scripts under <code>/etc/init.d</code></li>
<li>walked away</li>
</ul>
<p><br />
</p>
<p><code>/etc/init.d</code></p>
<ul>
<li>all shell scripts –&gt;</li>
<li>relied on double forking</li>
<li>everything handled manually</li>
<li><code>/etc/init.d/httpd restart</code></li>
<li><code>service httpd restart</code></li>
</ul>
</div><div class="column" style="width:50%;">
<div class="sourceCode" id="cb2"><pre class="sourceCode sh"><code class="sourceCode bash"><span id="cb2-1"><a href="#cb2-1" aria-hidden="true" tabindex="-1"></a><span class="co">#!/bin/bash</span></span>
<span id="cb2-2"><a href="#cb2-2" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-3"><a href="#cb2-3" aria-hidden="true" tabindex="-1"></a><span class="fu">start()</span> <span class="kw">{</span></span>
<span id="cb2-4"><a href="#cb2-4" aria-hidden="true" tabindex="-1"></a>  <span class="co"># start app</span></span>
<span id="cb2-5"><a href="#cb2-5" aria-hidden="true" tabindex="-1"></a><span class="kw">}</span></span>
<span id="cb2-6"><a href="#cb2-6" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-7"><a href="#cb2-7" aria-hidden="true" tabindex="-1"></a><span class="fu">stop()</span> <span class="kw">{</span></span>
<span id="cb2-8"><a href="#cb2-8" aria-hidden="true" tabindex="-1"></a>  <span class="co"># stop app</span></span>
<span id="cb2-9"><a href="#cb2-9" aria-hidden="true" tabindex="-1"></a><span class="kw">}</span></span>
<span id="cb2-10"><a href="#cb2-10" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb2-11"><a href="#cb2-11" aria-hidden="true" tabindex="-1"></a><span class="cf">case</span> <span class="st">&quot;</span><span class="va">$1</span><span class="st">&quot;</span> <span class="kw">in</span></span>
<span id="cb2-12"><a href="#cb2-12" aria-hidden="true" tabindex="-1"></a>    <span class="ss">start</span><span class="kw">)</span></span>
<span id="cb2-13"><a href="#cb2-13" aria-hidden="true" tabindex="-1"></a>       <span class="ex">start</span></span>
<span id="cb2-14"><a href="#cb2-14" aria-hidden="true" tabindex="-1"></a>       <span class="cf">;;</span></span>
<span id="cb2-15"><a href="#cb2-15" aria-hidden="true" tabindex="-1"></a>    <span class="ss">stop</span><span class="kw">)</span></span>
<span id="cb2-16"><a href="#cb2-16" aria-hidden="true" tabindex="-1"></a>       <span class="ex">stop</span></span>
<span id="cb2-17"><a href="#cb2-17" aria-hidden="true" tabindex="-1"></a>       <span class="cf">;;</span></span>
<span id="cb2-18"><a href="#cb2-18" aria-hidden="true" tabindex="-1"></a>    <span class="ss">restart</span><span class="kw">)</span></span>
<span id="cb2-19"><a href="#cb2-19" aria-hidden="true" tabindex="-1"></a>       <span class="ex">stop</span><span class="kw">;</span> <span class="ex">start</span></span>
<span id="cb2-20"><a href="#cb2-20" aria-hidden="true" tabindex="-1"></a>       <span class="cf">;;</span></span>
<span id="cb2-21"><a href="#cb2-21" aria-hidden="true" tabindex="-1"></a>    <span class="ss">status</span><span class="kw">)</span></span>
<span id="cb2-22"><a href="#cb2-22" aria-hidden="true" tabindex="-1"></a>       <span class="co"># do something to report status</span></span>
<span id="cb2-23"><a href="#cb2-23" aria-hidden="true" tabindex="-1"></a>       <span class="cf">;;</span></span>
<span id="cb2-24"><a href="#cb2-24" aria-hidden="true" tabindex="-1"></a>    <span class="pp">*</span><span class="kw">)</span></span>
<span id="cb2-25"><a href="#cb2-25" aria-hidden="true" tabindex="-1"></a>       <span class="bu">echo</span> <span class="st">&quot;Usage: </span><span class="va">$0</span><span class="st"> {start|stop|restart|status}&quot;</span></span>
<span id="cb2-26"><a href="#cb2-26" aria-hidden="true" tabindex="-1"></a><span class="cf">esac</span></span></code></pre></div>
</div>
</div>
</section>
<section id="problems" class="slide level2">
<h2>Problems</h2>
<ul>
<li>crash handling</li>
<li>dependencies</li>
<li>logging</li>
<li>slow</li>
<li><strong>things changed</strong></li>
</ul>
</section>
<section id="things-changed" class="slide level2">
<h2>Things changed</h2>
<ul>
<li>the internet</li>
<li>persistence</li>
<li>communication</li>
<li>lifecycle</li>
<li>daemon -&gt; service</li>
</ul>
</section>
<section id="systemd-provides" class="slide level2">
<h2>Systemd provides…</h2>
<ul>
<li>dependency handling</li>
<li>resource tracking</li>
<li>multiple types of services</li>
<li>parallel starting</li>
<li>automatic mounting</li>
<li>delayed activation</li>
<li><strong>system housekeeping</strong></li>
</ul>
</section></section>
<section id="how-do-i-use-it" class="title-slide slide level1">
<h1>How do I use it?</h1>
<p><code>systemctl</code>!</p>
<table>
<colgroup>
<col style="width: 30%" />
<col style="width: 69%" />
</colgroup>
<tbody>
<tr class="odd">
<td>See whats running:</td>
<td><code>systemctl status</code> <code>systemctl list-units</code></td>
</tr>
<tr class="even">
<td>Start/stop a service:</td>
<td><code>systemctl start httpd</code>
<code>systemctl stop  httpd</code></td>
</tr>
<tr class="odd">
<td>Start/stop on boot:</td>
<td><code>systemctl enable  httpd</code>
<code>systemctl disable httpd</code></td>
</tr>
<tr class="even">
<td>Show info on a service:</td>
<td><code>systemctl status httpd</code></td>
</tr>
<tr class="odd">
<td>Show dependencies:</td>
<td><code>systemctl list-dependencies httpd</code></td>
</tr>
</tbody>
</table>
<p>+ lots of other stuff, see later</p>
</section>

<section>
<section id="other-types-of-units" class="title-slide slide level1">
<h1>Other types of units</h1>
<table>
<colgroup>
<col style="width: 21%" />
<col style="width: 22%" />
<col style="width: 56%" />
</colgroup>
<thead>
<tr class="header">
<th>Unit Type</th>
<th>File Extension</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Service unit</td>
<td><code>.service</code></td>
<td>A system service / daemon.</td>
</tr>
<tr class="even">
<td>Scope unit</td>
<td><code>.scope</code></td>
<td>An externally created process.</td>
</tr>
<tr class="odd">
<td>Slice unit</td>
<td><code>.slice</code></td>
<td>A resource tracking group</td>
</tr>
<tr class="even">
<td>Snapshot unit</td>
<td><code>.snapshot</code></td>
<td>A saved state of the systemd manager.</td>
</tr>
<tr class="odd">
<td>Socket unit</td>
<td><code>.socket</code></td>
<td>An inter-process communication socket.</td>
</tr>
<tr class="even">
<td>Swap unit</td>
<td><code>.swap</code></td>
<td>A swap device or a swap file.</td>
</tr>
<tr class="odd">
<td>Timer unit</td>
<td><code>.timer</code></td>
<td>A systemd timer.</td>
</tr>
</tbody>
</table>
</section>
<section id="writing-units" class="slide level2">
<h2>Writing units</h2>
<div class="columns">
<div class="column" style="width:60%;">
<ul>
<li><code>[Unit]</code>
<ul>
<li>generic options</li>
<li>description, dependencies, etc</li>
</ul></li>
<li><code>[Unit Type]</code>
<ul>
<li>type-specific directives, e.g. <code>[Service]</code></li>
<li>what to execute for <code>.service</code></li>
<li>what to mount for <code>.mount</code></li>
<li>etc</li>
</ul></li>
<li><code>[Install]</code>
<ul>
<li>information about unit installation</li>
<li>used by <code>systemctl enable</code> and <code>disable</code></li>
</ul></li>
</ul>
</div><div class="column" style="width:40%;">
<div class="sourceCode" id="cb3"><pre
class="sourceCode ini"><code class="sourceCode ini"><span id="cb3-1"><a href="#cb3-1" aria-hidden="true" tabindex="-1"></a><span class="co"># /etc/systemd/system/the-bishop.service</span></span>
<span id="cb3-2"><a href="#cb3-2" aria-hidden="true" tabindex="-1"></a><span class="kw">[Unit]</span></span>
<span id="cb3-3"><a href="#cb3-3" aria-hidden="true" tabindex="-1"></a><span class="dt">Description</span><span class="ot">=</span><span class="st">The Bishop Discord Bot</span></span>
<span id="cb3-4"><a href="#cb3-4" aria-hidden="true" tabindex="-1"></a><span class="dt">After</span><span class="ot">=</span><span class="st">network-online.target</span></span>
<span id="cb3-5"><a href="#cb3-5" aria-hidden="true" tabindex="-1"></a><span class="dt">Wants</span><span class="ot">=</span><span class="st">network-online.target</span></span>
<span id="cb3-6"><a href="#cb3-6" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb3-7"><a href="#cb3-7" aria-hidden="true" tabindex="-1"></a><span class="kw">[Service]</span></span>
<span id="cb3-8"><a href="#cb3-8" aria-hidden="true" tabindex="-1"></a><span class="dt">Type</span><span class="ot">=</span><span class="st">simple</span></span>
<span id="cb3-9"><a href="#cb3-9" aria-hidden="true" tabindex="-1"></a><span class="dt">WorkingDirectory</span><span class="ot">=</span><span class="st">/var/bots/the-bishop/</span></span>
<span id="cb3-10"><a href="#cb3-10" aria-hidden="true" tabindex="-1"></a><span class="dt">ExecStartPre</span><span class="ot">=</span><span class="st">bundle install --deployment</span></span>
<span id="cb3-11"><a href="#cb3-11" aria-hidden="true" tabindex="-1"></a><span class="dt">ExecStart</span><span class="ot">=</span><span class="st">bundle exec ruby main.rb</span></span>
<span id="cb3-12"><a href="#cb3-12" aria-hidden="true" tabindex="-1"></a><span class="dt">Restart</span><span class="ot">=</span><span class="st">always</span></span>
<span id="cb3-13"><a href="#cb3-13" aria-hidden="true" tabindex="-1"></a><span class="dt">User</span><span class="ot">=</span><span class="st">bots</span></span>
<span id="cb3-14"><a href="#cb3-14" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb3-15"><a href="#cb3-15" aria-hidden="true" tabindex="-1"></a><span class="kw">[Install]</span></span>
<span id="cb3-16"><a href="#cb3-16" aria-hidden="true" tabindex="-1"></a><span class="dt">WantedBy</span><span class="ot">=</span><span class="st">multi-user.target</span></span></code></pre></div>
</div>
</div>
</section>
<section id="socket-activation" class="slide level2">
<h2>Socket Activation</h2>
<p>Don’t start the service until its needed!</p>
<p>Both local unix sockets and network ports supported</p>
<div class="columns">
<div class="column" style="width:50%;">
<div class="sourceCode" id="cb4"><pre
class="sourceCode ini"><code class="sourceCode ini"><span id="cb4-1"><a href="#cb4-1" aria-hidden="true" tabindex="-1"></a><span class="co"># /etc/systemd/systemd/foo.socket</span></span>
<span id="cb4-2"><a href="#cb4-2" aria-hidden="true" tabindex="-1"></a><span class="kw">[Unit]</span></span>
<span id="cb4-3"><a href="#cb4-3" aria-hidden="true" tabindex="-1"></a><span class="dt">Description</span><span class="ot">=</span><span class="st">Foo Socket</span></span>
<span id="cb4-4"><a href="#cb4-4" aria-hidden="true" tabindex="-1"></a><span class="dt">PartOf</span><span class="ot">=</span><span class="st">foo.service</span></span>
<span id="cb4-5"><a href="#cb4-5" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb4-6"><a href="#cb4-6" aria-hidden="true" tabindex="-1"></a><span class="kw">[Socket]</span></span>
<span id="cb4-7"><a href="#cb4-7" aria-hidden="true" tabindex="-1"></a><span class="dt">ListenStream</span><span class="ot">=</span><span class="dv">1234</span></span>
<span id="cb4-8"><a href="#cb4-8" aria-hidden="true" tabindex="-1"></a><span class="dt">ListenStream</span><span class="ot">=</span><span class="st">/run/foo.socket</span></span>
<span id="cb4-9"><a href="#cb4-9" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb4-10"><a href="#cb4-10" aria-hidden="true" tabindex="-1"></a><span class="kw">[Install]</span></span>
<span id="cb4-11"><a href="#cb4-11" aria-hidden="true" tabindex="-1"></a><span class="dt">WantedBy</span><span class="ot">=</span><span class="st">sockets.target</span></span></code></pre></div>
</div><div class="column" style="width:50%;">
<div class="sourceCode" id="cb5"><pre
class="sourceCode ini"><code class="sourceCode ini"><span id="cb5-1"><a href="#cb5-1" aria-hidden="true" tabindex="-1"></a><span class="co"># /etc/systemd/systemd/foo.service</span></span>
<span id="cb5-2"><a href="#cb5-2" aria-hidden="true" tabindex="-1"></a><span class="kw">[Unit]</span></span>
<span id="cb5-3"><a href="#cb5-3" aria-hidden="true" tabindex="-1"></a><span class="dt">Description</span><span class="ot">=</span><span class="st">Foo Service</span></span>
<span id="cb5-4"><a href="#cb5-4" aria-hidden="true" tabindex="-1"></a><span class="dt">After</span><span class="ot">=</span><span class="st">network.target foo.socket</span></span>
<span id="cb5-5"><a href="#cb5-5" aria-hidden="true" tabindex="-1"></a><span class="dt">Requires</span><span class="ot">=</span><span class="st">foo.socket</span></span>
<span id="cb5-6"><a href="#cb5-6" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb5-7"><a href="#cb5-7" aria-hidden="true" tabindex="-1"></a><span class="kw">[Service]</span></span>
<span id="cb5-8"><a href="#cb5-8" aria-hidden="true" tabindex="-1"></a><span class="dt">Type</span><span class="ot">=</span><span class="st">simple</span></span>
<span id="cb5-9"><a href="#cb5-9" aria-hidden="true" tabindex="-1"></a><span class="dt">ExecStart</span><span class="ot">=</span><span class="st">/usr/bin/python3 /somewhere/serve.py</span></span>
<span id="cb5-10"><a href="#cb5-10" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb5-11"><a href="#cb5-11" aria-hidden="true" tabindex="-1"></a><span class="co"># this is optional! service doesn&#39;t need to be enabled</span></span>
<span id="cb5-12"><a href="#cb5-12" aria-hidden="true" tabindex="-1"></a><span class="kw">[Install]</span></span>
<span id="cb5-13"><a href="#cb5-13" aria-hidden="true" tabindex="-1"></a><span class="dt">WantedBy</span><span class="ot">=</span><span class="st">multi-user.target</span></span></code></pre></div>
</div>
</div>
</section>
<section id="parameterized-instantiated-units" class="slide level2">
<h2>Parameterized / Instantiated units</h2>
<p>This is what the <code>@</code> is</p>
<div class="sourceCode" id="cb6"><pre
class="sourceCode ini"><code class="sourceCode ini"><span id="cb6-1"><a href="#cb6-1" aria-hidden="true" tabindex="-1"></a><span class="co"># /usr/lib/systemd/system/getty@.service</span></span>
<span id="cb6-2"><a href="#cb6-2" aria-hidden="true" tabindex="-1"></a><span class="kw">[Unit]</span></span>
<span id="cb6-3"><a href="#cb6-3" aria-hidden="true" tabindex="-1"></a><span class="dt">Description</span><span class="ot">=</span><span class="st">Getty on %I</span></span>
<span id="cb6-4"><a href="#cb6-4" aria-hidden="true" tabindex="-1"></a><span class="dt">...</span></span>
<span id="cb6-5"><a href="#cb6-5" aria-hidden="true" tabindex="-1"></a><span class="kw">[Service]</span></span>
<span id="cb6-6"><a href="#cb6-6" aria-hidden="true" tabindex="-1"></a><span class="dt">ExecStart</span><span class="ot">=</span><span class="st">-/sbin/agetty --noclear %I $TERM</span></span>
<span id="cb6-7"><a href="#cb6-7" aria-hidden="true" tabindex="-1"></a><span class="dt">...</span></span></code></pre></div>
<table>
<tbody>
<tr class="odd">
<td><code>%n</code></td>
<td>Full unit name (i.e. <code>getty@ttyS1.service</code>)</td>
</tr>
<tr class="even">
<td><code>%p</code></td>
<td>Prefix name (i.e. <code>getty</code>)</td>
</tr>
<tr class="odd">
<td><code>%i</code> or <code>%I</code></td>
<td>Instance name (i.e. <code>ttyS1</code>)</td>
</tr>
<tr class="even">
<td><code>%H</code></td>
<td>Host name</td>
</tr>
</tbody>
</table>
</section></section>
<section id="system-journal-journalctl"
class="title-slide slide level1">
<h1>System journal: <code>journalctl</code></h1>
<table>
<colgroup>
<col style="width: 44%" />
<col style="width: 56%" />
</colgroup>
<tbody>
<tr class="odd">
<td>Look at the latest messages:</td>
<td><code>journalctl -e</code></td>
</tr>
<tr class="even">
<td>Watch the latest messages:</td>
<td><code>journalctl -f/--follow</code>   (like tail)</td>
</tr>
<tr class="odd">
<td>Log from previous boots:</td>
<td><code>journalctl -b/--boot -1</code></td>
</tr>
<tr class="even">
<td>Only show output from one unit:</td>
<td><code>journalctl -u/--unit httpd.service</code></td>
</tr>
</tbody>
</table>
</section>

<section id="user-sessions" class="title-slide slide level1">
<h1>User sessions</h1>
<p>Useful for running user-level daemons, e.g. the DE, noise
cancelling</p>
<p>same commands the system sessions, with <code>--user</code></p>
<ul>
<li><code>systemctl --user ...</code></li>
<li><code>journalctl --user ...</code></li>
</ul>
<p>Units under <code>~/.config/systemd/user/</code></p>
</section>

<section>
<section id="other-cool-stuff-systemd-can-do"
class="title-slide slide level1">
<h1>Other cool stuff systemd can do</h1>

</section>
<section id="systemd-cgtop" class="slide level2">
<h2><code>systemd-cgtop</code></h2>
<p>See resource usage per-service, and per-app!</p>
<p><img data-src="images/cgtop.png" /></p>
</section>
<section id="systemd-analyze" class="slide level2">
<h2><code>systemd-analyze</code></h2>
<p>See what services are taking the longest</p>
<p><code>systemd-analyze blame</code></p>
</section>
<section class="slide level2">

</section></section>
<section id="further-resources" class="title-slide slide level1">
<h1>Further resources</h1>
<ul>
<li><a href="https://www.youtube.com/watch?v=o_AIw9bGogo">The Tragedy of
systemd</a>, great talk on the history and controversy of systemd</li>
<li><a href="https://cs312.osuosl.org/slides/08_systemd.html">CS312
systemd slides</a></li>
<li><a href="https://0pointer.de/blog/projects/systemd.html">Rethinking
PID 1</a>, Poeterring’s initial post about systemd</li>
<li><a
href="https://www.freedesktop.org/wiki/Software/systemd/">Official site
+ documentation</a></li>
</ul>
<p>How to see what’s running How to change what’s running Socket
activation Parameterize units Security options Editing units Journalctl
and filtering</p>
</section>
    </div>
  </div>

  <script src="https://unpkg.com/reveal.js@^4//dist/reveal.js"></script>

  <!-- reveal.js plugins -->
  <script src="https://unpkg.com/reveal.js@^4//plugin/notes/notes.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/search/search.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/zoom/zoom.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://revealjs.com/config/
      Reveal.initialize({
        // Display controls in the bottom right corner
        controls: false,

        // Help the user learn the controls by providing hints, for example by
        // bouncing the down arrow when they first encounter a vertical slide
        controlsTutorial: true,

        // Determines where controls appear, "edges" or "bottom-right"
        controlsLayout: 'bottom-right',

        // Visibility rule for backwards navigation arrows; "faded", "hidden"
        // or "visible"
        controlsBackArrows: 'faded',

        // Display a presentation progress bar
        progress: true,

        // Display the page number of the current slide
        slideNumber: false,

        // 'all', 'print', or 'speaker'
        showSlideNumber: 'all',

        // Add the current slide number to the URL hash so that reloading the
        // page/copying the URL will return you to the same slide
        hash: true,

        // Start with 1 for the hash rather than 0
        hashOneBasedIndex: false,

        // Flags if we should monitor the hash and change slides accordingly
        respondToHashChanges: true,

        // Push each slide change to the browser history
        history: false,

        // Enable keyboard shortcuts for navigation
        keyboard: true,

        // Enable the slide overview mode
        overview: true,

        // Disables the default reveal.js slide layout (scaling and centering)
        // so that you can use custom CSS layout
        disableLayout: false,

        // Vertical centering of slides
        center: true,

        // Enables touch navigation on devices with touch input
        touch: true,

        // Loop the presentation
        loop: false,

        // Change the presentation direction to be RTL
        rtl: false,

        // see https://revealjs.com/vertical-slides/#navigation-mode
        navigationMode: 'default',

        // Randomizes the order of slides each time the presentation loads
        shuffle: false,

        // Turns fragments on and off globally
        fragments: true,

        // Flags whether to include the current fragment in the URL,
        // so that reloading brings you to the same fragment position
        fragmentInURL: true,

        // Flags if the presentation is running in an embedded mode,
        // i.e. contained within a limited portion of the screen
        embedded: false,

        // Flags if we should show a help overlay when the questionmark
        // key is pressed
        help: true,

        // Flags if it should be possible to pause the presentation (blackout)
        pause: true,

        // Flags if speaker notes should be visible to all viewers
        showNotes: false,

        // Global override for autoplaying embedded media (null/true/false)
        autoPlayMedia: null,

        // Global override for preloading lazy-loaded iframes (null/true/false)
        preloadIframes: null,

        // Number of milliseconds between automatically proceeding to the
        // next slide, disabled when set to 0, this value can be overwritten
        // by using a data-autoslide attribute on your slides
        autoSlide: 0,

        // Stop auto-sliding after user input
        autoSlideStoppable: true,

        // Use this method for navigation when auto-sliding
        autoSlideMethod: null,

        // Specify the average time in seconds that you think you will spend
        // presenting each slide. This is used to show a pacing timer in the
        // speaker view
        defaultTiming: null,

        // Enable slide navigation via mouse wheel
        mouseWheel: false,

        // The display mode that will be used to show slides
        display: 'block',

        // Hide cursor if inactive
        hideInactiveCursor: true,

        // Time before the cursor is hidden (in ms)
        hideCursorTime: 5000,

        // Opens links in an iframe preview overlay
        previewLinks: false,

        // Transition style (none/fade/slide/convex/concave/zoom)
        transition: 'slide',

        // Transition speed (default/fast/slow)
        transitionSpeed: 'default',

        // Transition style for full page slide backgrounds
        // (none/fade/slide/convex/concave/zoom)
        backgroundTransition: 'fade',

        // Number of slides away from the current that are visible
        viewDistance: 3,

        // Number of slides away from the current that are visible on mobile
        // devices. It is advisable to set this to a lower number than
        // viewDistance in order to save resources.
        mobileViewDistance: 2,

        // The "normal" size of the presentation, aspect ratio will be preserved
        // when the presentation is scaled to fit different resolutions. Can be
        // specified using percentage units.
        width: 1600,

        height: 900,

        // reveal.js plugins
        plugins: [
          RevealNotes,
          RevealSearch,
          RevealZoom
        ]
      });
    </script>
    </body>
</html>
